(defun c:BDL (/ doc vars vals selectionSet i blkRef blkName block)
  (vl-load-com)
  (setq doc (vla-get-ActiveDocument (vlax-get-acad-object))
        vars '("cmdecho")
        vals (mapcar 'getvar vars))
  (mapcar 'setvar vars '(0))
  (vla-StartUndoMark doc)

  ;; Lấy các đối tượng đang được chọn
  (setq selectionSet (ssget '((0 . "INSERT"))))

  ;; Duyệt qua các đối tượng đang chọn
  (if selectionSet
    (progn
      (setq i 0)
      (while (< i (sslength selectionSet))
        (setq blkRef (vlax-ename->vla-object (ssname selectionSet i))
              blkName (vla-get-EffectiveName blkRef)
              block (vla-item (vla-get-Blocks doc) blkName))
        (if (and (> (vlax-get block 'Count) 0)
                 (= (vlax-get block 'IsLayout) 0)
                 (= (vlax-get block 'IsXRef) 0))
          (vlax-for item block
            (if (vlax-property-available-p item 'Layer T) (vlax-put item 'Layer "0"))
            (if (vlax-property-available-p item 'Color T) (vlax-put item 'Color 0))
          )
        )
        (setq i (1+ i))
      )
    )
  )

  (command "REGEN")
  (mapcar 'setvar vars vals)
  (vla-EndUndoMark doc)
  (princ)
)
